// 1Cdllrun.cpp : Defines the entry point for the DLL application.
//
// Savransky Oleg <olsavr@ukr.net>
//

#include "stdafx.h"
#include "cdbeng.h"
#include <stdlib.h>

struct pStore{
	char TableName[10];
	CStoreObj * PointStore;
};

static pStore ArrStore[11];
static CItemList ItemLs;
static CDataDictionary * DDict;
static CMetaDataCont * CMD = new CMetaDataCont;
static CDBEngDB7 DBEng(CMD);

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	char lnc[100], dbs[100], dict[12];
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
			if (GetPrivateProfileString("Bases","1CBase","",lnc,sizeof(lnc),".\\cdbeng.ini")>0)
			{
				if (GetPrivateProfileString("Bases","DDict","",dict,sizeof(dict),".\\cdbeng.ini")==0)
					strcpy(dict, "1cv7.dd;"); else strcat(dict, ";");
				strcpy(dbs, lnc);
				strcat(dbs, dict);
				strcat(dbs, lnc);
				strcat(lnc, "1Cv7.LCK");
				CString dbpath = dbs;
				FirstInit();
				DBEng.data[5] = (long)dbpath.GetString();
				InitLockCtrl(0, lnc);
				CDataBase7::SetDefault((CDataBase7*)&DBEng);
				DBEng.AttachDDB7Service(DBEng.CreateDDB7Service());
				DBEng.Open(0,0,0,0,1);
				CUsersSet::Init((CDataBase7*)&DBEng);
				DDict = *(CDataDictionary **)((long)&DBEng + 0x20);
				ArrStore[0].TableName[0] = '\0';
				ArrStore[1].TableName[0] = '\0';
				break;
			}
			else return FALSE;
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
			break;
		case DLL_PROCESS_DETACH:
			DBEng.Close();
    }
    return TRUE;
}

CStoreObj * FindStore(char * TableName)
{
	CStoreObj * StObj = 0;
	if (strlen(TableName) < 12)
	{
		//CharUpper(TableName);
		if (strcmp(TableName,ArrStore[0].TableName) == 0)
			StObj = ArrStore[0].PointStore;
		else
		{
			int size = sizeof(ArrStore)/sizeof(ArrStore[0]);
			for (int i = 1;(i < size && ArrStore[i].TableName != "");i++)
			{
				if (strcmp(TableName,ArrStore[i].TableName) ==0)
				{
					StObj = ArrStore[i].PointStore;
					ArrStore[0].PointStore = StObj;
					strcpy(ArrStore[0].TableName, ArrStore[i].TableName);
					break;
				}
				else if (ArrStore[i].TableName[0] == '\0')
					break;
			}
			if (i < size && StObj == 0)
				if (CTable * tab1 = DDict->GetTable(TableName))
				{
					tab1->OpenAccess(sm2,sc2);
					CIndex * ind1 = tab1->GetIndex(0);
					//CIndex * ind1 = tab1->GetIndex(-1);
					if (strncmp(TableName,"SC",2) == 0)
						StObj = new CStore_Spr(tab1, ind1);
					else if (strcmp(TableName, "1SJOURN") == 0)
					{
						//ind1 = tab1->GetIndex(4);
						StObj = new CStore_Jrn(tab1, ind1);
					}
					else if (strcmp(TableName, "1SOPER") == 0)
						StObj = new CStore_Op(tab1, ind1);
					else if (strcmp(TableName, "1SENTRY") == 0)
						StObj = new CStore_En(tab1, ind1); 
					else if (strncmp(TableName,"DH",2) == 0)
						StObj = new CStore_Dh(tab1, ind1);
					else if (strncmp(TableName,"DT",2) == 0)
						StObj = new CStore_Dt(tab1, ind1);
					else if (strcmp(TableName, "1SCONST") == 0)
						StObj = new CStore_Cnt(tab1, ind1); 
					else if (strcmp(TableName, "1SBLOB") == 0)
						StObj = new CStore_Bl(tab1, ind1); 
					else if (strcmp(TableName, "1SBKTTL") == 0)
						StObj = new CStore_Ctl(tab1, ind1); 
					else if (strcmp(TableName, "1SBKTTLC") == 0)
						StObj = new CStore_Ctlc(tab1, ind1); 
					else if (strcmp(TableName, "1SCRDOC") == 0)
						StObj = new CStore_Cr(tab1, ind1); 
					else return 0;
					//StObj->SetOrderIndex(ind1);
					ArrStore[i+1].TableName[0] = '\0';
					strcpy(ArrStore[i].TableName, TableName);
					strcpy(ArrStore[0].TableName, TableName);
					ArrStore[0].PointStore = ArrStore[i].PointStore = StObj;
				}
		}
	}
	return StObj;
}

extern "C" __declspec(dllexport) int TRecNo(char * TableName)
{
	CStoreObj * StObj = (CStoreObj *) FindStore(TableName);
	if (StObj)
		return StObj->RecNo;
	else return 0;
}

extern "C" __declspec(dllexport) int TGoto(char * TableName, enum NavCtrl nav)
{
	CStoreObj * StObj = (CStoreObj *) FindStore(TableName);
	if (StObj)
		return StObj->Goto(nav,1);
	else return 0;
}

extern "C" __declspec(dllexport) int TNGoto(char * TableName, char * NomID)
{	//    
	CStoreObj * StObj = (CStoreObj *) FindStore(TableName);
	if (StObj)
	{
		CompCtl mode = cc0;
		//StObj->Table->GetIndex(-1);
		//CIndex * ind = (StObj->Index) ? StObj->Index : StObj->Table->GetIndex(0);
		//EdKey KeyObj(ind,0,0);
		//EdKey KeyObj(StObj->Index,0,0);
		//if (StObj->PointFunc ==0x20207AB0)	CIndex * ind = (StObj->Index) ? StObj->Index : StObj->Table->GetIndex(0);
		//else CIndex * ind = StObj->Table->GetIndex(0);
		EdKey KeyObj(StObj->Table->GetIndex(0),0,0);
		if (strlen(NomID) > (unsigned int)StObj->Table->GetIndex(0)->GetField(0)->sizeCField)
		{
			SSbKindInfo SbKind[3];
			CKeyObj * PKeyObj = 0;
			char key[100];
			unsigned int i = 0, lnkey = 0;
			if (StObj->PointFunc ==0x2020778C)
			{
				CnKey CKeyObj(StObj->Table->GetIndex(0),0,0);
				PKeyObj = &CKeyObj;
			}
			else if (StObj->PointFunc == 0x2020793C)
			{
				BlKey CKeyObj(StObj->Table->GetIndex(0),0,0);
				PKeyObj = &CKeyObj;
			}
			else if (StObj->PointFunc ==0x20207AB0)
			{
				CIndex * ind = (StObj->Index) ? StObj->Index : StObj->Table->GetIndex(0);
				CtlKey CKeyObj(ind,0,0);
				PKeyObj = &CKeyObj;
			}
			else if (StObj->PointFunc == 0x20207AC8)
			{
				CtlKey CKeyObj(StObj->Table->GetIndex(0),0,0);
				PKeyObj = &CKeyObj;
			}
			else if (StObj->PointFunc == 0x20207888)
			{
				CrKey CKeyObj(StObj->Table->GetIndex(0),0,0);
				PKeyObj = &CKeyObj;
			}
			if (PKeyObj)
			{
				while ((strlen(NomID) > lnkey) && StObj->Table->GetIndex(0)->GetField(i))
				{
					int lnfld = StObj->Table->GetIndex(0)->GetField(i)->sizeCField;
					strncpy(key, &NomID[lnkey], lnfld);
					key[lnfld] = 0;
					switch (StObj->PointFunc)
					{
						case 0x2020778C:
							if (i == 1)
								((CnKey *)PKeyObj)->ObjID.SetlObjID(CharIDToLong36(key,6));
							else if (i == 0)
								((CnKey *)PKeyObj)->Fields[0] = CharIDToLong36(key,strlen(key));
							else if (i == 2)
								((CnKey *)PKeyObj)->Fields[1] = StringToJDate(key);
							else lnkey = strlen(NomID);
							break;
						case 0x2020793C:
							if (i == 1)
								((BlKey *)PKeyObj)->ObjID.SetlObjID(CharIDToLong36(key,strlen(key)));
							else if (i < 3)
								((BlKey *)PKeyObj)->Fields[i/2] = CharIDToLong36(key,strlen(key));
							else lnkey = strlen(NomID);
							break;
						case 0x20207AC8:
							if (i == 0)
							{
								((CtlKey *)PKeyObj)->Fields[0] = ((CStore_Ctl *)StObj)->Gmt;
								*(long*)((long)PKeyObj + 0x30) = (long)&SbKind[0];
								((CtlKey *)PKeyObj)->Fields[1] = StringToJDate(key);
							}
							else if (i == 1)
							{
								((CtlKey *)PKeyObj)->Value.CVal.val = 5;
								((CtlKey *)PKeyObj)->Value.CVal.TypeCValue = 0xB;
								((CtlKey *)PKeyObj)->Value.CVal.dd[2] = CharIDToLong36(key,6);
							}
							else if (i == 3)
								((CtlKey *)PKeyObj)->ObjID[0].SetlObjID(CharIDToLong36(key,strlen(key)));
							else if (i == 7)
								((CtlKey *)PKeyObj)->ObjID[1].SetlObjID(CharIDToLong36(key,strlen(key)));
							else if (i == 2)
								(*(long*)((long)PKeyObj + 0x2C)) = atoi(key) - 1;
							else lnkey = strlen(NomID);
							break;
						case 0x20207AB0:
							if (i == 0)
							{
								((CtlKey *)PKeyObj)->val = 0;
								PKeyObj->data[0] = 0x20207ABC;
								((CtlKey *)PKeyObj)->Fields[0] = ((CStore_Ctl *)StObj)->GetBuh;
								//*(long*)((long)PKeyObj + 0x30) = (long)&SbKind[0];
								((CtlKey *)PKeyObj)->Fields[1] = StringToJDate(key);
							}
							else if (i == 1)
							{
								((CtlKey *)PKeyObj)->Value.CVal.val = 5;
								((CtlKey *)PKeyObj)->Value.CVal.TypeCValue = 0xB;
								((CtlKey *)PKeyObj)->Value.CVal.dd[2] = CharIDToLong36(key,6);
							}
							else if (i == 2)
								((CtlKey *)PKeyObj)->val = atoi(key) - 1;
								//(*(long*)((long)PKeyObj + 0x2C)) = atoi(key) - 1;
							else if (i < 5)
								((CtlKey *)PKeyObj)->ObjID[i-3].SetlObjID(CharIDToLong36(key,6));
							else lnkey = strlen(NomID);
							break;
						case 0x20207888:
							if (i == 0)
								((CrKey *)PKeyObj)->ObjID.SetlObjID(CharIDToLong36(key,6));
							else if (i == 1)
								((CrKey *)PKeyObj)->fMDID = CharIDToLong36(key,strlen(key));
							else if (i == 2)
							{
								char * cr = 0;
								ValueAndTypeFromBuf(key,((CrKey *)PKeyObj)->CVal,0x24,cr,1);
							}
					}
					lnkey = lnkey + StObj->Table->GetIndex(0)->GetField(i++)->sizeCField;
				}
				PKeyObj->SetKeyLength(i,0);
				return StObj->Goto(PKeyObj,mode,1);
			}
			else KeyObj.ObjID.SetlObjID(CharIDToLong36(NomID,strlen(NomID)));
		}
		else
		{
			KeyObj.ObjID.SetlObjID(CharIDToLong36(NomID,strlen(NomID)));
		}
		if (StObj->PointFunc == 0x202077ec)		KeyObj.data[0] = 0x20207804; //mode = cc3;
		return StObj->Goto(&KeyObj,mode,1);
	}
	else return 0;
}

extern "C"  __declspec(dllexport) int TNew(char * TableName)
{
	CStoreObj * StObj = (CStoreObj *) FindStore(TableName);
	if (StObj)
	{
		EdKey KeyObj(StObj->Table->GetIndex(0),0,0);
		KeyObj.ObjID.SetlObjID(0);
		StObj->Goto(&KeyObj,cc0,1);
		if (StObj->PointFunc ==  0x202077b0)
		{
			int ks = atoi(TableName + 2);
			//int lcod = atoi(((CStore_Spr *)StObj)->Cod);
			CObjID ID = ((CDataBase7*)&DBEng)->GetMaxObjID(ks);
			ID.data[0]++;
			((CStore_Spr *)StObj)->ObjID1 = ID;
			((CDataBase7*)&DBEng)->SetMaxObjID(ks,ID);
		}
		else if (StObj->PointFunc == 0x202077ec)
		{
			CObjID ID = ((CDataBase7*)&DBEng)->GetMaxObjID(0);
			ID.data[0]++;
			((CStore_Jrn *)StObj)->ObjID1 = ID;
			((CStore_Jrn *)StObj)->Field5 = GetNowTime();
			((CDataBase7*)&DBEng)->SetMaxObjID(0,ID);
		}
		else if (StObj->PointFunc == 0x202079FC)
			((CStore_Op *)StObj)->fTime = GetNowTime();
		else if (StObj->PointFunc == 0x20207A44)
			((CStore_En *)StObj)->fTime = GetNowTime();
		else if (StObj->PointFunc == 0x20207888)
			((CStore_Cr *)StObj)->fTime = GetNowTime();
		if (StObj->New()) return 1;
	}
	return 0;
}

extern "C"  __declspec(dllexport) int TDelete(char * TableName, int mark)
{
	CStoreObj * StObj = (CStoreObj *) FindStore(TableName);
	if (StObj)
		if (!mark) return StObj->Delete();
		else
		{
			if (StObj->PointFunc == 0x202077b0)
			{
				((CStore_Spr *)StObj)->Field5 = (((CStore_Spr *)StObj)->Field5) ? 0 : 1;
				return 1;
			}
		    else if (StObj->PointFunc == 0x202077ec)
			{
				((CStore_Jrn *)StObj)->fMark = (((CStore_Jrn *)StObj)->fMark) ? 0 : 1;
				return 1;
			}
		}
	return 0;
}

extern "C"  __declspec(dllexport) void TSetOrderIndex(char * TableName, int Index)
{
	CTable * tab1 = DDict->GetTable(TableName);
	CIndex * ind1 = tab1->GetIndex(Index);
	CStoreObj * StObj = (CStoreObj *) FindStore(TableName);
	if (StObj) StObj->SetOrderIndex(ind1);
}

extern "C"  __declspec(dllexport) void TGetField(char * TableName, int Field, char * FieldValue)
{
	CField * fld;
	CStoreObj * StObj = (CStoreObj *) FindStore(TableName);
	if (StObj && (long)(fld = StObj->Table->GetField(Field)) && StObj->RecNo)
	{
		int size = fld->sizeCField + 1;
		StObj->FX_String(Field, FieldValue,size,0);
	}
	else FieldValue[0] = 0;
}

void SetCValue(CTypeValue * CTypeVal, char * FieldValue)
{
	if (CTypeVal->CVal.TypeCValue == 1)
		CTypeVal->CVal.Num.FromString(FieldValue,0);
	else if (CTypeVal->CVal.TypeCValue == 2)
		CTypeVal->CVal = FieldValue;
	else if (CTypeVal->CVal.TypeCValue == 3)
		CTypeVal->CVal.CDate = StringToJDate(FieldValue);
	else if (CTypeVal->CVal.TypeCValue == 0xB)
		CTypeVal->CVal.dd[2] = CharIDToLong36(FieldValue,strlen(FieldValue));
	else if (CTypeVal->CVal.TypeCValue == 0xC)
	{
		CTypeVal->CVal.dd[0] = CharIDToLong36(FieldValue,4);
		CTypeVal->CVal.dd[2] = CharIDToLong36(FieldValue+6,4);
	}
}

extern "C"  __declspec(dllexport) void TSetField(char * TableName, int Field, char * FieldValue)
{
	CStoreObj * StObj = (CStoreObj *) FindStore(TableName);
	if (StObj)
		if (StObj->PointFunc == 0x202077b0)
		{
			int typespr = 0;
			CTable * tab = DDict->GetTable(TableName);
			if (strcmp(tab->GetField(2)->FieldName, "CODE") == 0)		 typespr = 2;
			else if (strcmp(tab->GetField(4)->FieldName, "ISMARK") == 0) typespr = 1;
			if (Field == 0)
				((CStore_Spr*)StObj)->ObjID1.SetlObjID(CharIDToLong36(FieldValue,strlen(FieldValue)));
			else if (Field == 1 && typespr == 2)
				((CStore_Spr*)StObj)->ObjID2.SetlObjID(CharIDToLong36(FieldValue,strlen(FieldValue)));
			else if (Field - typespr/2 == 1)
				((CStore_Spr*)StObj)->Cod = FieldValue;
			else if (Field - typespr/2 == 2)
				((CStore_Spr*)StObj)->Descr = FieldValue;
			else if (Field - typespr/2 == 3)
			{
				if (typespr == 2)
					((CStore_Spr*)StObj)->Field4 = (!(atoi(FieldValue)-1)) ? 1 : 0;
				else if (typespr == 1)
					((CStore_Spr*)StObj)->ObjID3.SetlObjID(CharIDToLong36(FieldValue,strlen(FieldValue)));
			}
			else if (Field - typespr > 4 && Field - typespr < ((CStore_Spr*)StObj)->ColValue + 5)
				SetCValue(&((CStore_Spr*)StObj)->ArrayValue[Field - 5 - typespr], FieldValue);
		}
		else if (StObj->PointFunc == 0x202077ec)
		{
			int fld;
			switch (Field)
			{
				case 0:
					((CStore_Jrn *)StObj)->IDJourn = CharIDToLong36(FieldValue,strlen(FieldValue));
					break;
				case 1:
					((CStore_Jrn *)StObj)->ObjID1.SetlObjID(CharIDToLong36(FieldValue,strlen(FieldValue)));
					break;
				case 2:
					((CStore_Jrn *)StObj)->IDDDef = CharIDToLong36(FieldValue,strlen(FieldValue));
					break;
				case 3:
					fld = atoi(FieldValue);
					((CStore_Jrn *)StObj)->flField[3] = (fld&16)/16;
					((CStore_Jrn *)StObj)->flField[4] = fld&1;
					((CStore_Jrn *)StObj)->flField[5] = (fld&2)/2;
					((CStore_Jrn *)StObj)->flField[6] = (fld&4)/4;
					((CStore_Jrn *)StObj)->fAppcode = fld/32;
					break;
				case 4:
					 ((CStore_Jrn *)StObj)->Field4 = StringToJDate(FieldValue);
					break;
				case 6:
					((CStore_Jrn *)StObj)->Field6 = FieldValue;
					break;
				case 7:
					((CStore_Jrn *)StObj)->Field7 = FieldValue;
					break;
				case 8:
					 fld = atoi(FieldValue);
					 ((CStore_Jrn *)StObj)->flField[0] = fld&1;
					 ((CStore_Jrn *)StObj)->flField[1] = (fld&2)/2;
					 ((CStore_Jrn *)StObj)->flField[2] = fld/4;
					break;
				case 10:
					((CStore_Jrn *)StObj)->fActcnt = CharIDToLong36(FieldValue,strlen(FieldValue));
					break;
				case 5: case 9:
					break;
				default:
					if (Field < *(int*)((long)StObj->Table + 0x38))
					{
						int i = 0;
						CField * fld = StObj->Table->GetField(Field);
						if (fld->TypeCField == 1)	i = ((CStore_Jrn *)StObj)->ColInt;
						while (((CStore_Jrn *)StObj)->FIntNo[i] != Field && i++ < ((CStore_Jrn *)StObj)->ColInt + ((CStore_Jrn *)StObj)->ColValue);
						if (fld->TypeCField == 1)
							((CStore_Jrn *)StObj)->ArrValue[i - ((CStore_Jrn *)StObj)->ColInt].CVal.dd[2] = CharIDToLong36(FieldValue,strlen(FieldValue));
						else if (fld->TypeCField == 2)
							((CStore_Jrn *)StObj)->ArrInt[i] = atoi(FieldValue);
					}
			}
		}
		else if (StObj->PointFunc == 0x202079FC)
		{
			switch (Field)
			{
				case 0:
					((CStore_Op *)StObj)->ObjID.SetlObjID(CharIDToLong36(FieldValue,strlen(FieldValue)));
					break;
				case 1:
					((CStore_Op *)StObj)->Field1.CVal.CDate = StringToJDate(FieldValue);
					break;
				case 3:
					((CStore_Op *)StObj)->Field3.CVal = FieldValue;
					break;
				case 4:
					((CStore_Op *)StObj)->Field4.CVal.Num.FromString(FieldValue,0);
					break;
				case 5:
					((CStore_Op *)StObj)->Field5 = (strcmp(FieldValue, "*")) ? 0 : 1;
			}
		}
		else if (StObj->PointFunc == 0x20207A44)
		{
			if (Field == 0)
				((CStore_En *)StObj)->ObjID.SetlObjID(CharIDToLong36(FieldValue,strlen(FieldValue)));
			else if (Field < 3)
				((CStore_En *)StObj)->fNum[Field-1] = atoi(FieldValue);
			else if (Field == 3)
				((CStore_En *)StObj)->fDate = StringToJDate(FieldValue);
			//else if (Field == 4)
			else if (Field > 4 && Field < 11)
				if (((CStore_En *)StObj)->VField[Field - 5].CVal.TypeCValue == 1)
					((CStore_En *)StObj)->VField[Field - 5].CVal.Num.FromString(FieldValue,0);
				else
					((CStore_En *)StObj)->VField[Field - 5].CVal.dd[2] = CharIDToLong36(FieldValue,strlen(FieldValue));
			else if (Field == 11)
			{
				if (toupper(*FieldValue) == 'D')
					((CStore_En *)StObj)->Field11 = 0;
				else if (toupper(*FieldValue) == 'K')
					((CStore_En *)StObj)->Field11 = 1;
				else if (*FieldValue == ' ')
					((CStore_En *)StObj)->Field11 = 2;
			}
			else if (Field == 12)
				((CStore_En *)StObj)->fActive = (strcmp(FieldValue, "*")) ? 0 : 1;
			else if (Field == 15)
				((CStore_En *)StObj)->Field15 = atoi(FieldValue);
			else if (Field > 15 && Field < (16 + ((CStore_En *)StObj)->Dataf[0]))
					((CStore_En *)StObj)->arCField1[Field-16].CVal = FieldValue;
			else if (Field > (15 + ((CStore_En *)StObj)->Dataf[0]) && Field < (34 + ((CStore_En *)StObj)->Dataf[0]))
			{
				//long * val;
				int i = (Field - 16 - ((CStore_En *)StObj)->Dataf[0])%3;
				long * val = &((CStore_En *)StObj)->arField1[(Field - 16 - ((CStore_En *)StObj)->Dataf[0])/3*2+i/2];
				CValue * vl = &((CStore_En *)StObj)->arCField2[(Field - 16 - ((CStore_En *)StObj)->Dataf[0])/3].CVal;
				switch (i)
				{
					case 1:
						if (strlen(FieldValue)==8)
						{
							vl->val = 0;	vl->TypeCValue = 3;
							vl->CDate = StringToJDate(FieldValue);
						}
						else
						{
							vl->val = 5;	vl->TypeCValue = 0x0B;
							if (strlen(FieldValue)>8)
							{
								vl->val = 0;	vl->TypeCValue = 0x0C;
								vl->dd[0] = CharIDToLong36(FieldValue,4);
							}
							vl->dd[2] = CharIDToLong36(FieldValue,strlen(FieldValue));
						}
						ChangeItem(vl,*val);
						break;
					case 2:
						*val = atoi(FieldValue);
						break;
					case 0:
						*val = CharIDToLong36(FieldValue,strlen(FieldValue));
						AddItem(*val);
				}
			}
		}
		else if (StObj->PointFunc == 0x20207858)
		{
			if (Field == 0)
				((CStore_Dh *)StObj)->ObjID.SetlObjID(CharIDToLong36(FieldValue,strlen(FieldValue)));
			else if (Field < ((CStore_Dh *)StObj)->ColValue + 4)
				SetCValue(&((CStore_Dh *)StObj)->ArrCVal1[Field-1], FieldValue);
		}
		else if (StObj->PointFunc == 0x20207870)
		{
			if (Field == 0)
				((CStore_Dt *)StObj)->ObjID.SetlObjID(CharIDToLong36(FieldValue,strlen(FieldValue)));
			if (Field == 1)
				((CStore_Dt *)StObj)->Field1 = atoi(FieldValue);
			else if (Field < ((CStore_Dt *)StObj)->ColValue + 2)
				SetCValue(&((CStore_Dt *)StObj)->ArrCVal[Field-2], FieldValue);
		}
		else if (StObj->PointFunc == 0x2020778C)
		{
			switch (Field)
			{
				case 0:
					((CStore_Cnt *)StObj)->ObjID.SetlObjID(CharIDToLong36(FieldValue,strlen(FieldValue)));
					break;
				case 1:
					((CStore_Cnt *)StObj)->FieldID = CharIDToLong36(FieldValue,strlen(FieldValue));
					break;
				case 2:
					((CStore_Cnt *)StObj)->fDate = StringToJDate(FieldValue);
					break;
				case 3:
				((CStore_Cnt *)StObj)->Field3 = atoi(FieldValue);
					break;
				case 4:
					strcpy(((CStore_Cnt *)StObj)->fValue,FieldValue);
					break;
				case 5:
					((CStore_Cnt *)StObj)->DocID.SetlObjID(CharIDToLong36(FieldValue,strlen(FieldValue)));
					break;
				case 6:
					((CStore_Cnt *)StObj)->fTime = TimeFromString(FieldValue);
					break;
				case 7:
					((CStore_Cnt *)StObj)->fActNo = atoi(FieldValue);
					break;
				case 8:
					((CStore_Cnt *)StObj)->fLineNo = atoi(FieldValue);
					break;
				case 9:
					strcpy(((CStore_Cnt *)StObj)->fTValue,FieldValue);
			}
		}
		else if (StObj->PointFunc == 0x2020793C)
		{
			switch (Field)
			{
				case 1:
					((CStore_Bl *)StObj)->ObjID.SetlObjID(CharIDToLong36(FieldValue,strlen(FieldValue)));
					break;
				case 0:
					((CStore_Bl *)StObj)->FieldID = CharIDToLong36(FieldValue,strlen(FieldValue));
					break;
				case 2:
					((CStore_Bl *)StObj)->Field2 = atoi(FieldValue);
					break;
				case 3:
					strcpy(((CStore_Bl *)StObj)->fBlock,FieldValue);
			}
		}
		else if (StObj->PointFunc == 0x20207AC8)
		{
			if (Field == 0)
				((CStore_Ctl *)StObj)->fDate = StringToJDate(FieldValue);
			else if (Field < 3)
				((CStore_Ctl *)StObj)->ObjID[Field - 1].SetlObjID(CharIDToLong36(FieldValue,strlen(FieldValue)));
			else if (Field == 3)
				((CStore_Ctl *)StObj)->fKind = Field - 1;
			else if (Field < 11)
				((CStore_Ctl *)StObj)->CNum[Field - 4].FromString(FieldValue,0);
			else if (Field == 11)
			{
				int fld = atoi(FieldValue);
				((CStore_Ctl *)StObj)->Data1[0] =  fld&1;
				((CStore_Ctl *)StObj)->Data1[1] = (fld&2)/2;
				((CStore_Ctl *)StObj)->Data1[2] = (fld&4)/4;
			}
			else if (Field == 12)
				((CStore_Ctl *)StObj)->CTypVal.CVal.dd[2] = CharIDToLong36(FieldValue,strlen(FieldValue));
			else if (Field < 22)
			{
				int i = (Field - 13)%3;
				CValue * vl = &((CStore_Ctl *)StObj)->CVals[(Field - 13)/3];
				long * val = &((CStore_Ctl *)StObj)->SSbKind[(Field - 13)/3].value[i/2];
				switch (i)
				{
					case 0:
						*val = CharIDToLong36(FieldValue,strlen(FieldValue));
						AddItem(((CStore_Ctl *)StObj)->SSbKind[(Field - 13)/3].value[0]);
						break;
					case 1:
						if (strlen(FieldValue)==8)
						{
							vl->val = 0;	vl->TypeCValue = 3;
							vl->CDate = StringToJDate(FieldValue);
						}
						else
						{
							vl->val = 5;	vl->TypeCValue = 0x0B;
							if (strlen(FieldValue)>8)
							{
								vl->val = 0;	vl->TypeCValue = 0x0C;
								vl->dd[0] = CharIDToLong36(FieldValue,4);
							}
							vl->dd[2] = CharIDToLong36(FieldValue,strlen(FieldValue));
						}
						ChangeItem(vl,*val);
						break;
					case 2:
						*val = atoi(FieldValue);
				}
			}
		}
		else if (StObj->PointFunc == 0x20207AB0)
		{
			if (Field == 0)
				((CStore_Ctlc *)StObj)->fDate = StringToJDate(FieldValue);
			else if (Field < 4)
				((CStore_Ctlc *)StObj)->ObjID[Field - 1].SetlObjID(CharIDToLong36(FieldValue,strlen(FieldValue)));
			else if (Field == 4)
				((CStore_Ctlc *)StObj)->fKind = Field - 1;
			else if (Field < 8)
				((CStore_Ctlc *)StObj)->CNum[Field - 5].FromString(FieldValue,0);
			else if (Field == 10)
				((CStore_Ctlc *)StObj)->CTypVal.CVal.dd[2] = CharIDToLong36(FieldValue,strlen(FieldValue));
			else if ((Field = 8) || (Field = 9))
			{
				int fld = atoi(FieldValue);
				((CStore_Ctlc *)StObj)->Data1[Field - 8 + 0] =  fld&1;
				((CStore_Ctlc *)StObj)->Data1[Field - 8 + 2] = (fld&2)/2;
				((CStore_Ctlc *)StObj)->Data1[Field - 8 + 4] = (fld&4)/4;
			}
		}
		else if (StObj->PointFunc == 0x20207888)
		{
			if (Field == 0)
				((CStore_Cr *)StObj)->fMDID = CharIDToLong36(FieldValue,strlen(FieldValue));
			else if (Field == 1)
			{
				char * cr = 0;
				ValueAndTypeFromBuf(FieldValue,((CStore_Cr *)StObj)->CVal,0x24,cr,1);
			}
			else if (Field == 2)
				((CStore_Cr *)StObj)->fDate = StringToJDate(FieldValue);
			else if (Field == 4)
				((CStore_Cr *)StObj)->ObjID.SetlObjID(CharIDToLong36(FieldValue,strlen(FieldValue)));
			else if (Field == 5)
				((CStore_Cr *)StObj)->fFlags = atoi(FieldValue);
		}
}

extern "C"  __declspec(dllexport) int TUpdate(char * TableName)
{
	CStoreObj * StObj = (CStoreObj *) FindStore(TableName);
	if (StObj && StObj->Locking(wr))
	{
		BeginTransaction();
		if (StObj->PointFunc == 0x202077b0)
			((CStore_Spr*)StObj)->Field6++;
		else if (StObj->PointFunc == 0x202077ec)
			((CStore_Jrn*)StObj)->Verst++;
		StObj->Table->PutTLock(m2);
		StObj->Update();
		StObj->Locking(rd);
		CUsersSet::IncrNetChangesCnt();
		CommitTransaction();
	}
	return 0;
}

extern "C"  __declspec(dllexport) int TLocking(char * TableName, enum LockCtrl lock)
{
	CStoreObj * StObj = (CStoreObj *) FindStore(TableName);
	if (StObj) return StObj->Locking(lock);
	else return 0;
}
