
// The following ifdef block is the standard way of creating macros which make exporting 
// from a DLL simpler. All files within this DLL are compiled with the CDBENG_EXPORTS
// symbol defined on the command line. this symbol should not be defined on any project
// that uses this DLL. This way any other project whose source files include this file see 
// CDBENG_API functions as being imported from a DLL, wheras this DLL sees symbols
// defined with this macro as being exported.

#if defined(__BORLANDC__)
  //#define CDBENG_API CALLBAK _export
  #define CDBENG_API _stdcall _export
#else
 #ifdef CDBENG_EXPORTS
 #define CDBENG_API __declspec(dllexport)
 #else
 #define CDBENG_API __declspec(dllimport)
 #endif
#endif

//#include <afx.h>
#include <windows.h>

// This class is exported from the cdbeng.dll
void FirstInit();
void AddItem(long);
void ChangeItem(class CValue *, long);

struct StringData{
	unsigned int size;
	unsigned int fsize;
};

class CString{
public:
	CString();
	//CString(){Init("");};
	//CDBENG_API CString();
	//CDBENG_API CString(LPCTSTR lpsz);
	CString(LPCTSTR lpsz){Init(lpsz);};
	LPTSTR GetString() const{return m_pchData;};
	operator LPCTSTR() const{return m_pchData;};
	const CString& operator=(LPCSTR lpsz);
	~CString();
protected:
	LPTSTR m_pchData;   // pointer to ref counted string data
	Init(LPCTSTR lpsz);
};

class CDate{
	long Value;
public:
   CDBENG_API CDate(int,int,int) ;
};

class CMetaDataCont{
public:
	CDBENG_API CMetaDataCont(void);
};

class CDataDictionary{
	long data[28];
public:
	 CDBENG_API CDataDictionary(char const *, char const *, char const *, char const *);
	 CDBENG_API int Open(char const *);
	 CDBENG_API class CTable  * GetTable(int);
	 CDBENG_API class CTable  * GetTable(char const  *);
};

class CDBEngDB7{
public:
	long data[10];
	CDBEngDB7(CMetaDataCont *);
	void OpenDB(void){CDBEngDB7::Open(0,0,0,0,1);};
	virtual CDBENG_API int Open(int,int,int,int,int);
    virtual CDBENG_API int Close(void);
	virtual CDBENG_API int AttachDDB7Service(class CDDB7Service  *);
	virtual CDBENG_API class CDDB7Service  * CreateDDB7Service(void);
};

class CDataBase7{
public:
	CDBENG_API void InitUIDCtrlSet(void);
	CDBENG_API class CObjID & GetMaxObjID(long);
	CDBENG_API void SetMaxObjID(long,class CObjID const  &);
	CDBENG_API static class CDataBase7 * GetDefault(void);
	CDBENG_API static void SetDefault(class CDataBase7  *);
};

class CStoreObj{
public:
	long PointFunc;
	int RecNo;
	long value;
	CTable * Table; //0xC;
	class CIndex * Index;
	long Data[4];
	CDBENG_API CStoreObj(class CTable  *,class CIndex  *);
	CDBENG_API int SetSourceTable(class CTable  *);
	CDBENG_API void SetOrderIndex(class CIndex  *);
    CDBENG_API void FX_String(int,char  *,long,int);
	CDBENG_API void FX_Int(int,int &,int);
    CDBENG_API int Goto(enum NavCtrl,int) ;
    CDBENG_API int Goto(class CKeyObj  *,enum CompCtl,int);
	CDBENG_API class  CRecAddr GetRecAddr(void)const;
    CDBENG_API int Locking(enum LockCtrl);
    CDBENG_API int Update(void);
	CDBENG_API int Delete(void);
    CDBENG_API int New(void);
};

class CTable{
public:
    CDBENG_API int OpenAccess(enum ShareModeCtl,enum SafetyCtl);
    CDBENG_API int PutTLock(enum TLockModeCtl);
    CDBENG_API class CIndex  * GetIndex(int);
	CDBENG_API class CField  * GetField(int);
	CDBENG_API class CField  * GetField(char const  *);
	CDBENG_API class CIndex  * GetIndex(char const  *);
	CDBENG_API enum  TLockModeCtl GetTLockMode(void)const;
};

class CIndex{
public:
	CDBENG_API class CField  * GetField(int);
};

class CField{
public:
	long fpoint;
	char * FieldName;
	long data;
	long TypeCField;
	int sizeCField;
};

class CLnkLockCtrl{
private:
protected:
//	inline CDBENG_API CLnkLockCtrl(char const *);
	CDBENG_API CLnkLockCtrl(char const *);
};

class CObjID{
public:
	long data[2];
	CDBENG_API CObjID();
	CDBENG_API void SetlObjID(long);
	CDBENG_API long GetlObjID(void)const;
	CDBENG_API class  CString GetString(void)const;
	CDBENG_API int FromString(class CString const  &);
};

class CKeyObj{
public:
	long data[5];
	//CObjID ObjID;
	CDBENG_API CKeyObj(class CIndex  *,int,int);
    CDBENG_API void SetKeyLength(int,int);
};

class CItem{
public:
	long itpoint;
	char * string;
	CDBENG_API CItem(char const  *);
};

class CItemList{
public:
	long dd[6];
	CDBENG_API CItemList();
	CDBENG_API void RemoveItem(int,int);
	CDBENG_API int AddItem(class CGenericItem  *);
	CDBENG_API int InsertItem(int,class CGenericItem  *);
	CDBENG_API virtual int  LoadFromString(char const  *,int  *);
};

class CSbCntTypeDef{
public:
	long data[22];
	long arrCType;
	long NumbCType;
	long dd[14];
	CDBENG_API CSbCntTypeDef(class CItemList const  &);
};

class CSbKindDef{
public:
	long data[14];
	CDBENG_API CSbKindDef(class CItemList const  &);
};

class CNumeric{
public:
	long data[11];
    CDBENG_API class CNumeric  & FromString(char const  *,char  *  *);
};

class CValue{
protected:
	CDBENG_API void Init(void);
public:
	long IDValue;
	long sizeCValue;
	long val;
	long TypeCValue;
	CNumeric Num;
	char * strValue;
	//CString * strValue;
	long CDate;
	long dd[4];
	CDBENG_API CValue();
	CDBENG_API class CValue const  & operator=(char const  *);
	CDBENG_API class CValue const  & operator=(class CDate);
	CDBENG_API void SetType(class CType const  &);
//  void  __thiscall CValue::SetObjID(class CObjID) 
};

class CMetaDataObjArray{
public:
	long data[6];
	CDBENG_API int AddItem(class CMetaDataObj *);
	CDBENG_API class CMetaDataObj * GetItem(long)const;
};

class CBuhDef{
public:
	long data[5];
    class CMetaDataObjArray MDArray;
	long data1[20];
    class CMetaDataObjArray MDArray1;
	long data2[70];
	CDBENG_API CBuhDef();
	CDBENG_API void LoadFromList(class CItemList const  &);
	CDBENG_API class CMetaDataTypedObj * GetAccountingDivisionDef(void);
	CDBENG_API class CSbKindToType * GetSbKindToType(void);
	CDBENG_API void ClearSbKindToType(void);
};

class CValueTable{
public:
	long data[15];
	CDBENG_API CValueTable(void);
	virtual CDBENG_API int AddColumn(class CString const  &,class CType const  &,class CString const  &,int,class CString const  &,int);
};

class CType{
public:
	long data[3];
	CDBENG_API CType(int,long);
	CDBENG_API CType(int,int,int);
};

class CTypedValue{
public:
	CValue CVal;
	CDBENG_API CTypedValue();
};

class CTypeValue{
public:
	CValue CVal;
	CTypeValue();
};

class SSbKindInfo{
public:
	long value[2];
	CDBENG_API SSbKindInfo();
};

CDBENG_API void FX_MDID(class CStoreObj *,int,long &,int);
CDBENG_API long GetNowTime(void);
CDBENG_API long TimeFromString(char const *);
CDBENG_API int InitLockCtrl(int, char const *);
CDBENG_API int CommitTransaction(void);
CDBENG_API int BeginTransaction(void);
CDBENG_API class CString  &    MakeUpper(class CString  &);
CDBENG_API long  CharIDToLong36(char const *,int);
CDBENG_API class CMetaDataCont * GetMetaData(void);
CDBENG_API class CValue & ValueAndTypeFromBuf(char const *,class CValue &,int,char const *,int);
extern "C" {
	CDBENG_API long StringToJDate(char *);
	CDBENG_API JDateToString(char *, long JDate);
}

enum ShareModeCtl{sm1,sm2,sm3};
enum SafetyCtl{sc1,sc2,sc3};
enum NavCtrl{r0,first,last,next,prev};
enum LockCtrl{l0,wr,rd};
enum TLockModeCtl{m0,m1,m2};
enum CompCtl{cc0,cc1,cc2,cc3};

class EdKey: public CKeyObj{
public:
	CObjID ObjID;
	EdKey(class CIndex  *,int,int);
};

class JrnKey: public CKeyObj{
public:
	long IDJourn;
	long fDate;
	long fTime;
	CObjID ObjID;
	JrnKey(class CIndex  *,int,int);
};

class VKey: public CKeyObj{
public:
	CObjID ObjID1;
	long Field1;
	long Field2;
	CObjID ObjID2;
	long val;
	CTypedValue Value;
	long data1[5];
	VKey(class CIndex  *,int,int);
};

class CnKey: public CKeyObj{
public:
	CObjID ObjID;
	long Fields[3];
	CObjID ObjID1;
	long val;
	CnKey(class CIndex  * ind,int i1,int i2): CKeyObj(ind,i1,i2){data[0] = (long)0x20207798;}
};

class BlKey: public CKeyObj{
public:
	CObjID ObjID;
	long Fields[2];
	BlKey(class CIndex  * ind,int i1,int i2): CKeyObj(ind,i1,i2){data[0] = (long)0x20207948;}
};

class CtlKey: public CKeyObj{
public:
	long Fields[2];
	CObjID ObjID[3];
	long val;
	CTypedValue Value;
	CtlKey(class CIndex  * ind,int i1,int i2): CKeyObj(ind,i1,i2){data[0] = (long)0x20207AD4;}
};

class CrKey: public CKeyObj{
public:
	CValue CVal;
	long fMDID;
	CObjID ObjID;
	CrKey(class CIndex  * ind,int i1,int i2): CKeyObj(ind,i1,i2){data[0] = (long)0x20207894;}
};

class CStore_Spr: public CStoreObj{
public:
	int ColValue;
	CObjID ObjID1;
	CObjID ObjID2;
	CString Cod;
	CString Descr;
	CObjID ObjID3;
	int Field4;
	int Field5;
	int Field6;
	long DataS[4];
	CTypeValue * ArrayValue;
	Replace(int NoField, char * value);
	Replace(int NoField, int value);
	CStore_Spr(class CTable  *,class CIndex  *);
	~CStore_Spr();
};

class CStore_Jrn: public CStoreObj{
public:
	int ColValue;
	int ColInt;
	long ColRF;
	long IDJourn;
	CObjID ObjID1;
	long IDDDef;
	long Field4;
	long Field5;
	CString Field6;
	CString Field7;
	int flField[7];
	int fMark;
	long fActcnt;
	int Verst;
	long ArrValRF;
	long Data1;
	int fAppcode;
	int ArrNumRF;
	CTypeValue * ArrValue;
	long FValNo;
	long Arr_ff;
	long * ArrInt;
	long * FIntNo;
	CStore_Jrn(class CTable  *,class CIndex  *);
	~CStore_Jrn();
};

class CStore_Op: public CStoreObj{
public:
	int ColValue;
	long Data1[2];
	CObjID ObjID;
	CTypedValue Field1;
	long fTime;
	CTypedValue Field3;
	CTypedValue Field4;
	int Field5;
	long Data2;
	CStore_Op(class CTable  *,class CIndex  *);
};

class CStore_En: public CStoreObj{
public:
	int ColValue;
	long DataEn[5];
	CObjID ObjID;
	long fNum[2];
	long fDate;
	long fTime;
	CTypedValue VField[6];
	long Field11;
	long fActive;
	long val1;
	long Field15;
	long Dataf[7];
	CTypedValue * arCField1;
	CTypedValue * arCField2;
	CTypedValue * arCField3;
	long * arField1;
	long * arField2;
	long val2;
	//long ArrValue[14];
	//CTypedValue ArrField[7];
	//CBuhDef CBuh1;
	CValueTable CValTab;
	CStore_En(class CTable  *,class CIndex  *);
	~CStore_En();
};

class CStore_Dh: public CStoreObj{
public:
	int ColValue;
	long ColCVal1;
	long ColCVal2;
	CObjID ObjID;
	CTypeValue * ArrCVal1;
	long ArrNoFld1;
	long Arr_ff1;
	CTypeValue * ArrCVal2;
	long ArrNoFld2;
	CTypeValue * ArrCVal3;
	long ArrNoFld3;
	long Arr_ff2;
	CStore_Dh(class CTable  *,class CIndex  *);
	~CStore_Dh();
};

class CStore_Dt: public CStoreObj{
public:
	int ColValue;
	CObjID ObjID;
	long Field1;
	CTypeValue * ArrCVal;
	long ArrNoFld;
	long Arr_ff;
	CStore_Dt(class CTable  *,class CIndex  *);
	~CStore_Dt();
};

class CStore_Cnt: public CStoreObj{
public:
	CObjID ObjID;
	long FieldID;
	long fDate;
	long Field3;
	CObjID DocID;
	long fTime;
	long fActNo;
	long fLineNo;
	char fValue[24];
	char fTValue[4];
	CStore_Cnt(class CTable  *,class CIndex  *);
};

class CStore_Bl: public CStoreObj{
public:
	long FieldID;
	CObjID ObjID;
	long Field2;
	char fBlock[80];
	CStore_Bl(class CTable  *,class CIndex  *);
};

class CStore_Ctl: public CStoreObj{
public:
	long IntValue;
	long GetBuh;
	long Gmt;
	long fDate;
	CObjID ObjID[2];
	long fKind;
	CNumeric CNum[7];
	long Data1[4];
	long Vals;
	long Kind;
	CTypedValue CTypVal;
	CValue CVals[3];
	SSbKindInfo SSbKind[3];
	CStore_Ctl(class CTable  *,class CIndex  *);
};

class CStore_Ctlc: public CStoreObj{
public:
	long IntValue;
	long GetBuh;
	long Gmt;
	long fDate;
	CObjID ObjID[3];
	long fKind;
	CNumeric CNum[3];
	long Data1[7];
	CTypedValue CTypVal;
	CStore_Ctlc(class CTable  *,class CIndex  *);
};

class CStore_Cr: public CStoreObj{
public:
	CValue CVal;
	long fMDID;
	CObjID ObjID;
	long fDate;
	long fTime;
	long fFlags;
	CStore_Cr(class CTable  *,class CIndex  *);
};

class CUsersSet{
public:
	CDBENG_API static int IncrNetChangesCnt(void);
	CDBENG_API static int Init(class CDataBase7  *);
};